package com.datacloudsec.scan.tasks.scheduler.time;

import com.datacloudsec.exception.UEException;
import java.util.Calendar;

/* loaded from: com_datacloudsec_scan_tasks_scheduler_time.jar:com/datacloudsec/scan/tasks/scheduler/time/TimeMonthly.class */
public class TimeMonthly implements ITime {
    private int day;
    private int hour;
    private int minute;

    public TimeMonthly(int day, int hour, int minute) {
        if (day < 1 || day > 31) {
            throw new UEException("day:1-31");
        }
        if (hour < 0 || hour > 23) {
            throw new UEException("hour:0-23");
        }
        if (minute < 0 || minute > 59) {
            throw new UEException("minute:0-59");
        }
        this.day = day;
        this.hour = hour;
        this.minute = minute;
    }

    @Override // com.datacloudsec.scan.tasks.scheduler.time.ITime
    public int calcSecond(long currTime) throws Exception {
        Calendar cale = Calendar.getInstance();
        cale.setTimeInMillis(currTime);
        cale.set(5, Math.min(getMaxMonth(1), this.day));
        cale.set(11, this.hour);
        cale.set(12, this.minute);
        cale.set(13, 0);
        long v = cale.getTimeInMillis();
        if (v <= currTime) {
            cale.set(2, cale.get(2) + 1);
            cale.set(5, Math.min(getMaxMonth(2), this.day));
            v = cale.getTimeInMillis();
        }
        return (int) ((v - currTime) / 1000);
    }

    private int getMaxMonth(int v) {
        Calendar cale = Calendar.getInstance();
        cale.set(2, cale.get(2) + v);
        cale.set(5, 0);
        return cale.get(5);
    }
}
